
	OUTPUT "redirect.ttp"

	move.l 4(sp),a0	; basepage
	lea 128(a0),a3		; the command line
	move.l $18(a0),a1
	add.l $1c(a0),a1	; end address of my used space
	add.l #$200,a1		; room for the stack
	move.l a1,sp		; stack !
	sub.l a0,a1
	move.l a1,-(sp)
	move.l a0,-(sp)
	clr.w -(sp)
	move #$4a,-(sp)
	trap #1				; MSHRINK, reduce space
	lea 12(sp),sp

	moveq #0,d0
	move.b (a3)+,d0	; command line length
	beq.s no_file		; if zero, then no filename specified

	clr.b 0(a3,d0.w)	; else, make sure that the command line ends with zero	
	clr -(sp)			; standard attribute
	pea (a3)				; the name in the command line
	move #60,-(sp)		; fcreate
	trap #1
	addq.l #8,sp
	
	move d0,handle		; saves the handle
	bmi.s no_file		; if negative, then creation has failed !

		
	move d0,-(sp)		; my file
	move #1,-(sp)		; standard output handle
	move #70,-(sp)		; fforce -> redirect standard output to my file!
	trap #1
	addq.l #6,sp		
	
	st mode
	bra.s common
	
no_file:
	sf mode

common:	
	pea text(pc)						; my text
	move.l #text_end-text,-(sp)	; number of bytes
	move #1,-(sp)						; standard output
	move #64,-(sp)						; fwrite
	trap #1
	lea 12(sp),sp
	
	
	tst.b mode			; display to the screen?
	beq.s no_file2		; yes! so just wait for a key and quit
	
	move handle,-(sp)			; else, my file
	move #62,-(sp)				; fclose
	trap #1
	addq.l #4,sp
	
	bra.s common_end	; don't wait for a key, just quit
	
no_file2:		
	move.l #$20002,-(sp)	; wait for a key
	trap #13
	addq.l #4,sp	

common_end:	
	clr -(sp)
	trap #1				; pterm, back to TOS
	
	data
	
text: dc.b "Hello World !"
text_end:
	even
	bss
mode: ds.w 1		; MSB = 0 for screen, FF for file
handle: ds.w 1		
	even
	
	end	    